=== added file 'INSTALL'
--- INSTALL	1970-01-01 00:00:00 +0000
+++ INSTALL	2005-10-19 07:04:01 +0000
@@ -0,0 +1,26 @@
+bzr install instructions
+************************
+
+Dependencies
+------------
+
+bzr requires Python2.4 and cElementTree:
+
+  http://effbot.org/zone/element-index.htm
+
+If you wish to access branches over sftp, you will need paramiko and
+pycrypto:
+
+  http://www.lag.net/paramiko/
+
+Installation
+------------
+
+To install bzr as a user, run
+
+  python setup.py install --home ~ 
+
+To install system-wide, run (as root)
+
+  python setup.py install
+

=== modified file 'NEWS'
--- NEWS	2005-10-19 07:25:40 +0000
+++ NEWS	2005-10-20 03:06:20 +0000
@@ -33,6 +33,8 @@
     * 'bzr pull' now accepts '--clobber' which will discard local changes
       and make this branch identical to the source branch. (Robert Collins)
 
+    * New sftp transport, based on Paramiko.  (Robey Pointer)
+
   TESTING:
 
     * The 'bzr selftest --pattern' option for has been removed, now 
@@ -129,6 +131,9 @@
       to apis like 'put', 'get' and 'has'. This is to provide consistent
       behaviour - it operates on url's only. (Robert Collins)
 
+    * Transports can register using register_lazy_transport, and they 
+      will be loaded when first used.  (Martin Pool)
+
   BUG FIXES:
 
     * Better handling of branches in directories with non-ascii names. 

=== modified file 'README'
--- README	2005-07-22 23:32:00 +0000
+++ README	2005-10-19 07:04:01 +0000
@@ -1,57 +1,30 @@
-*********************************
-Release notes for Bazaar-NG 0.0.5
-*********************************
-
-mbp@sourcefrog.net, May 2005, Canberra
-
-
-
-Caveats
--------
-
-
-
-* Don't use this for critical data; at the very least keep separate
-  regular snapshots of your tree.
-
-
-Dependencies
-------------
-
-This is mostly developed on Linux (Ubuntu); it should work on Unix,
-Windows, or OS X with relatively little trouble.
-
-The only dependency is Python 2.4.
-
-You may optionally install cElementTree to speed up some operations.
-This is strongly recommended if you are dealing with large trees.
-
-This package includes copies of two Python libraries, elementtree and
-urlgrabber.
-
-If you are building .deb or .rpm packages for bzr, please don't
-include these libraries but instead package them separately and depend
-on that.
-
-
-Installation
-------------
-
-The best way to install bzr is to symlink the ``bzr`` command onto a
-directory on your path.  For example::
-
-  ln -s ~/work/bzr/bzr ~/bin/bzr
-
-If you use a symlink for this, Python will be able to automatically
-find the bzr libraries.  Otherwise you must ensure they are listed on
-your $PYTHONPATH.
-
-After installing, please run the test suite to identify any problems
-on your platform::
-
-  ./bzr selftest
-
-If you use the setup.py script then bzr will be installed into the
-specified path.  In this case you must install ElementTree and
-urlgrabber separately.
-
+*******************************
+Release notes for Bazaar-NG 0.6
+*******************************
+
+bazaar-ng is a distributed/decentralized version control system.
+
+Features include:
+
+ * simple to use
+
+ * runs on Unix and Windows
+
+ * branches can be hosted on an http server with no special software
+
+ * full directory versioning including tracking subdirectories, 
+   file renames, symlinks and execute-bits
+   
+ * friendly interface that should be familiar to users of cvs, 
+   svn or other systems
+
+ * Python interface for extending and embedding, including a 
+   plugin interface
+
+ * strong integrity protection, including gpg-signing
+
+ * vibrant and active community
+
+For usage instructions see 
+http://bazaar.canonical.com/IntroductionToBzr
+or run "bzr help"

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-10-19 06:11:31 +0000
+++ bzrlib/commands.py	2005-10-19 06:44:53 +0000
@@ -450,9 +450,6 @@
     --profile
         Run under the Python profiler.
     """
-    import bzrlib.transport
-    bzrlib.transport.register_builtin_transports()
-    
     argv = [a.decode(bzrlib.user_encoding) for a in argv]
 
     opt_profile = opt_no_plugins = opt_builtin = False

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2005-10-19 11:54:59 +0000
+++ bzrlib/transport/__init__.py	2005-10-20 03:06:20 +0000
@@ -354,8 +354,6 @@
     # which has a lookup of None
     return _protocol_handlers[None](base)
 
-# Local transport should always be initialized
-import bzrlib.transport.local
 
 def urlescape(relpath):
     """Escape relpath to be a valid url."""
@@ -364,11 +362,22 @@
     return urllib.quote(relpath)
 
 
-def register_builtin_transports():
-    """Register all builtin transport modules.
-    
-    This happens as a sideeffect of importing the modules.
+def register_lazy_transport(scheme, module, classname):
+    """Register lazy-loaded transport class.
+
+    When opening a URL with the given scheme, load the module and then
+    instantiate the particular class.  
     """
-    import bzrlib.transport.local, \
-           bzrlib.transport.http, \
-           bzrlib.transport.sftp
+    def _loader(base):
+        mod = __import__(module, globals(), locals(), [classname])
+        klass = getattr(mod, classname)
+        return klass(base)
+    register_transport(scheme, _loader)
+ 
+
+# If nothing else matches, try the LocalTransport
+register_lazy_transport(None, 'bzrlib.transport.local', 'LocalTransport')
+register_lazy_transport('file://', 'bzrlib.transport.local', 'LocalTransport')
+register_lazy_transport('sftp://', 'bzrlib.transport.sftp', 'SFTPTransport')
+register_lazy_transport('http://', 'bzrlib.transport.http', 'HttpTransport')
+register_lazy_transport('https://', 'bzrlib.transport.http', 'HttpTransport')

=== modified file 'bzrlib/transport/http.py'
--- bzrlib/transport/http.py	2005-10-19 07:25:40 +0000
+++ bzrlib/transport/http.py	2005-10-20 03:06:20 +0000
@@ -228,6 +228,3 @@
         :return: A lock object, which should be passed to Transport.unlock()
         """
         raise TransportNotPossible('http does not support lock_write()')
-
-register_transport('http://', HttpTransport)
-register_transport('https://', HttpTransport)

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2005-10-19 07:25:40 +0000
+++ bzrlib/transport/local.py	2005-10-20 03:06:20 +0000
@@ -243,7 +243,3 @@
     def __del__(self):
         shutil.rmtree(self.base, ignore_errors=True)
         mutter("%r destroyed" % self)
-
-# If nothing else matches, try the LocalTransport
-register_transport(None, LocalTransport)
-register_transport('file://', LocalTransport)

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2005-10-19 11:54:59 +0000
+++ bzrlib/transport/sftp.py	2005-10-20 03:06:20 +0000
@@ -14,9 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""
-Implementation of Transport over SFTP, using paramiko.
-"""
+"""Implementation of Transport over SFTP, using paramiko."""
 
 import getpass
 import os
@@ -33,7 +31,7 @@
 try:
     import paramiko
 except ImportError:
-    error('The SFTP plugin requires paramiko.')
+    error('The SFTP transport requires paramiko.')
     raise
 
 
@@ -444,7 +442,3 @@
         except IOError:
             pass
         return False
-
-
-register_transport('sftp://', SFTPTransport)
-

